#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>
#include "convert.h"

#define ERROR(x...) \
	do{ \
		fprintf(stderr, "<E>"); \
		fprintf(stderr, x); \
		fprintf(stderr, "\n"); \
		exit(1); \
	}while(0)

int main(int argc, char **argv){
	int bc = 1;
	unsigned char b;
	void *ctx;
	
	if(argc - 3)
		ERROR("Wrong argcount");
	if(check_code(argv[1]) || check_code(argv[2]))
		ERROR("Wrong conversion requested");
	if(!(ctx = set_conversion(argv[1], argv[2])))
		ERROR("Can't set conversion");
	while(bc){
		bc = read(0, &b, 1);
		if(! (bc + 1)){
			ERROR("Error reading input: %s", strerror(errno));
		}
		if(!bc) continue;
		printf("%c", convert_byte(ctx, b));
	}
#if 0
	{
		char ccc[] = "bԠ";
		convert_string(set_conversion("pc2", "rom"), ccc);
		printf("Addon: pc2->rom (\"bԠ\") = (\"%s\")\n", ccc);
	}
#endif
	return 0;
}

/* vim: set ts=4 cindent shiftwidth=4 tw=0 : */
