#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>
#include "tables.h"
#include "convert.h"

int check_code(char *c){
	if(!strcmp(c, "rom")) return 0;
	if(!strcmp(c, "il2")) return 0;
	if(!strcmp(c, "pc2")) return 0;
	if(!strcmp(c, "kam")) return 0;
	return 1;
}

#define DSTT(x)	\
	switch(dd){ \
		case 'r': return conv_##x##_rom; break; \
		case 'i': return conv_##x##_il2; break; \
		case 'p': return conv_##x##_pc2; break; \
		case 'k': return conv_##x##_kam; break; \
		default: return NULL; \
	};

void *set_conversion(char *s, char *d){
	char ss = *s, dd = *d;

	if(check_code(s) || check_code(d))
		return NULL;
	switch(ss){
		case 'r': DSTT(rom); break;
		case 'i': DSTT(il2); break;
		case 'p': DSTT(pc2); break;
		case 'k': DSTT(kam); break;
		default: return NULL;
	}
}

unsigned char convert_byte(unsigned char *ctx, unsigned char b){
	if(!ctx)
		assert(! "You gave me NULL ctx, dude!");
	if(b > 127){
		if(ctx[b - 128]){
			return ctx[b - 128];
		}else{
			return b;
		}
	}else{
		return b;
	}
}

int convert_string(unsigned char *ctx, unsigned char *string){
	unsigned char *c = string;

	if(!ctx)
		assert(! "You gave me NULL ctx, dude!");
	while(*c){
		*(c++) = convert_byte(ctx, *c);
	}
	return 0;
}

/* vim: set ts=4 cindent shiftwidth=4 tw=0 : */
