#include <stdio.h>
#include <sys/farptr.h>
#include <go32.h> /* for _dos_ds */
#include <dpmi.h>
#include <pc.h>
#include <assert.h>
#include "fdefines.h"
/* Fonts: */
#include "kam.h"
#include "pc2.h"
#include "rom.h"

/* Detect EGA adapter */
t_bool is_ega(void){
	__dpmi_regs regs;

	regs.h.ah = 0x12;
	regs.h.bl = 0x10;
	__dpmi_int(0x10, &regs);
	return (regs.h.bl != 0x10);
}

/* Do font operation (aka [sg]et font) */
static t_bool vgafontop(t_bool op, unsigned char *arg){
	int i = 0;

	if(!is_ega())
		return 0;
	__asm__("cli");
	outportb(seq_port_reg, 0x00);
	outportb(seq_port_val, 0x01);
	outportb(seq_port_reg, 0x02);
	outportb(seq_port_val, 0x04);
	outportb(seq_port_reg, 0x04);
	outportb(seq_port_val, 0x07);
	outportb(seq_port_reg, 0x00);
	outportb(seq_port_val, 0x03);
	outportb(gr_port_reg, 0x04);
	outportb(gr_port_val, 0x02);
	outportb(gr_port_reg, 0x05);
	outportb(gr_port_val, 0x00);
	outportb(gr_port_reg, 0x06);
	outportb(gr_port_val, 0x00);
/*	__asm__("sti");*/
	_farsetsel(_dos_ds);
	for (i = 0; i < FONT_BUF; i++){
		if(!op)
			arg[i] = _farnspeekb(0xa0000 + i);
		else
			_farnspokeb(0xa0000 + i, arg[i]);
	}
/*	__asm__("cli");*/
	outportb(seq_port_reg, 0x00);
	outportb(seq_port_val, 0x01);
	outportb(seq_port_reg, 0x02);
	outportb(seq_port_val, 0x03);
	outportb(seq_port_reg, 0x04);
	outportb(seq_port_val, 0x03);
	outportb(seq_port_reg, 0x00);
	outportb(seq_port_val, 0x03);
	outportb(gr_port_reg, 0x04);
	outportb(gr_port_val, 0x00);
	outportb(gr_port_reg, 0x05);
	outportb(gr_port_val, 0x10);
	outportb(gr_port_reg, 0x06);
	outportb(gr_port_val, 0x0e);
	__asm__("sti");
	return 1;
}

/* Get current font */
t_bool vgagetfont(unsigned char *fnt){
	return vgafontop(0, fnt);
}

/* Set font */
t_bool vgasetfont(unsigned char *fnt){
	return vgafontop(1, fnt);
}

static unsigned char old_font[FONT_BUF];
static t_bool fonts_initialized = 0;

/* Font functions initialization */
t_bool font_init(void){
	if(fonts_initialized)
		assert(! "You can't call font_init() twice !");
	fonts_initialized = 1;
	return vgagetfont(old_font);
}

/* Font functions deinitialization */
t_bool font_shut(void){
	if(!fonts_initialized)
		assert(! "You can't call font_shut() before font_init() !");
	fonts_initialized = 0;
	return vgasetfont(old_font);
}

/* Font switching */
t_bool font_switch(char *name){
	if(!fonts_initialized)
		assert(! "You can't switch font before font_init() !");
	if(!strcmp(name, "pc2") || !strcmp(name, "PC2") || !strcmp(name, "czech")){
		vgasetfont(font_pc2);
		return 1;
	}
	if(!strcmp(name, "kam") || !strcmp(name, "KAM")){
		vgasetfont(font_kam);
		return 1;
	}
	if(!strcmp(name, "en") || !strcmp(name, "EN") || !strcmp(name, "english")
			|| !strcmp(name, "rom")){
		vgasetfont(font_rom);
		return 1;
	}
	return 0;
	return 0;
}

/* vim: set ts=4 cindent shiftwidth=4 tw=0 : */
