#ifndef __KTB_EN_H__
#define __KTB_EN_H__
#include <stdio.h>
#include "kdefines.h"
#include "keys.h"

/* no plain deadkeys here */

/* no shift deadkeys here */

static t_key_table_elem english_plain[KEY_TABLE_ELEMS] = {
	0, 0, W_KEY_ESC, W_KEY_F1, W_KEY_F2, W_KEY_F3, W_KEY_F4, W_KEY_F5, W_KEY_F6, W_KEY_F7,
	W_KEY_F8, W_KEY_F9, W_KEY_F10, W_KEY_F11, W_KEY_F12, '`', '1', '2', '3', '4', '5',
	'6', '7', '8', '9', '0', '-', '=', '\\', W_KEY_BACKSPACE, W_KEY_TAB, 'q', 'w',
	'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '[', ']', W_KEY_ENTER, W_KEY_CAPSLOCK,
	'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', '\'', 0, 'z', 'x', 'c',
	'v', 'b', 'n', 'm', ',', '.', '/', W_KEY_RSHIFT, W_KEY_LCTRL, W_KEY_LWIN,
	W_KEY_LALT, ' ', W_KEY_RALT, W_KEY_RWIN, W_KEY_RMENU, W_KEY_RCTRL, W_KEY_PRTSCR,
	W_KEY_SCROLLOCK, W_KEY_PAUSE, W_KEY_INS, W_KEY_HOME, W_KEY_PGUP, W_KEY_DEL, W_KEY_END,
	W_KEY_PGDN, W_KEY_UP, W_KEY_LEFT, W_KEY_DOWN, W_KEY_RIGHT, W_KEY_NUMLOCK,
	'/', '*', '-', '7', '8', '9', '+', '4', '5', '6', '1', '2', '3',
	W_KEY_ENTER, '0', '.',
};

static t_key_table_elem english_shift[KEY_TABLE_ELEMS] = {
	0, 0, W_KEY_ESC, W_KEY_F1, W_KEY_F2, W_KEY_F3, W_KEY_F4, W_KEY_F5, W_KEY_F6, W_KEY_F7,
	W_KEY_F8, W_KEY_F9, W_KEY_F10, W_KEY_F11, W_KEY_F12, '~', '!', '@', '#', '$', '%',
	'^', '&', '*', '(', ')', '_', '+', '|', W_KEY_BACKSPACE, W_KEY_TAB, 'Q', 'W',
	'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '{', '}', W_KEY_ENTER, W_KEY_CAPSLOCK,
	'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ':', '"', 0, 'Z', 'X', 'C',
	'V', 'B', 'N', 'M', '<', '>', '?', W_KEY_RSHIFT, W_KEY_LCTRL, W_KEY_LWIN,
	W_KEY_LALT, ' ', W_KEY_RALT, W_KEY_RWIN, W_KEY_RMENU, W_KEY_RCTRL, W_KEY_PRTSCR,
	W_KEY_SCROLLOCK, W_KEY_PAUSE, W_KEY_INS, W_KEY_HOME, W_KEY_PGUP, W_KEY_DEL, W_KEY_END,
	W_KEY_PGDN, W_KEY_UP, W_KEY_LEFT, W_KEY_DOWN, W_KEY_RIGHT, W_KEY_NUMLOCK,
	'/', '*', '-', '7', '8', '9', '+', '4', '5', '6', '1', '2', '3',
	W_KEY_ENTER, '0', '.',
};

static t_key_table_elem english_meta[KEY_TABLE_ELEMS] = {
	0, 0, W_KEY_ESC, W_KEY_F1, W_KEY_F2, W_KEY_F3, W_KEY_F4, W_KEY_F5, W_KEY_F6, W_KEY_F7,
	W_KEY_F8, W_KEY_F9, W_KEY_F10, W_KEY_F11, W_KEY_F12, '`', '1', '2', '3', '4', '5',
	'6', '7', '8', '9', '0', '-', '=', '\\', W_KEY_BACKSPACE, W_KEY_TAB, 'q', 'w',
	'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '[', ']', W_KEY_ENTER, W_KEY_CAPSLOCK,
	'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', '\'', 0, 'z', 'x', 'c',
	'v', 'b', 'n', 'm', ',', '.', '/', W_KEY_RSHIFT, W_KEY_LCTRL, W_KEY_LWIN,
	W_KEY_LALT, ' ', W_KEY_RALT, W_KEY_RWIN, W_KEY_RMENU, W_KEY_RCTRL, W_KEY_PRTSCR,
	W_KEY_SCROLLOCK, W_KEY_PAUSE, W_KEY_INS, W_KEY_HOME, W_KEY_PGUP, W_KEY_DEL, W_KEY_END,
	W_KEY_PGDN, W_KEY_UP, W_KEY_LEFT, W_KEY_DOWN, W_KEY_RIGHT, W_KEY_NUMLOCK,
	'/', '*', '-', '7', '8', '9', '+', '4', '5', '6', '1', '2', '3',
	W_KEY_ENTER, '0', '.',
};

/* no dead -> no compose */

t_key_layout english_layout = {
	NULL,
	NULL,
	english_plain,
	english_shift,
	english_meta,
	english_meta,
	english_meta,
	NULL
};

#endif

/* vim: set ts=4 cindent shiftwidth=4 tw=0 : */
