#ifndef __KTB_KAM_H__
#define __KTB_KAM_H__
#include <stdio.h>
#include "kdefines.h"
#include "keys.h"

#define TYPE		(unsigned char) /* explicit type - avoid gcc feature/bug */

#define RING		(TYPE '')
#define DBLACUTE	(TYPE '"')
#define ACUTE		(TYPE '\'')
#define CARON		(TYPE '~')

static t_key_table_elem kam_plain_deadkey[KEY_TABLE_ELEMS] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, ACUTE, DBLACUTE, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
};

static t_key_table_elem kam_shift_deadkey[KEY_TABLE_ELEMS] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, RING, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, CARON, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
};

static t_key_table_elem kam_plain[KEY_TABLE_ELEMS] = {
	0, 0, W_KEY_ESC, W_KEY_F1, W_KEY_F2, W_KEY_F3, W_KEY_F4, W_KEY_F5, W_KEY_F6, W_KEY_F7,
	W_KEY_F8, W_KEY_F9, W_KEY_F10, W_KEY_F11, W_KEY_F12,
	';', '+', TYPE '', TYPE '', TYPE '', TYPE '', TYPE '',
	TYPE '', TYPE '', TYPE '', TYPE '', '=', ACUTE, DBLACUTE,
	W_KEY_BACKSPACE, W_KEY_TAB, 'q', 'w', 'e', 'r', 't', 'y', 'u',
	'i', 'o', 'p', TYPE '', ')', W_KEY_ENTER, W_KEY_CAPSLOCK, 'a', 's', 'd',
	'f', 'g', 'h', 'j', 'k', 'l', TYPE '', TYPE '', W_KEY_LSHIFT, 'z',
	'x', 'c', 'v', 'b', 'n', 'm', ',', '.', '-', W_KEY_RSHIFT, W_KEY_LCTRL,
	W_KEY_LWIN, W_KEY_LALT, ' ', W_KEY_RALT, W_KEY_RWIN, W_KEY_RMENU, W_KEY_RCTRL,
	W_KEY_PRTSCR, W_KEY_SCROLLOCK, W_KEY_PAUSE, W_KEY_INS, W_KEY_HOME, W_KEY_PGUP, W_KEY_DEL,
	W_KEY_END, W_KEY_PGDN, W_KEY_UP, W_KEY_LEFT, W_KEY_DOWN, W_KEY_RIGHT,
	W_KEY_NUMLOCK, '/', '*', '-', '7', '8', '9', '+', '4', '5', '6', '1', '2',
	'3', W_KEY_ENTER, '0', '.',
};

static t_key_table_elem kam_shift[KEY_TABLE_ELEMS] = {
	0, 0, W_KEY_ESC, W_KEY_F1, W_KEY_F2, W_KEY_F3, W_KEY_F4, W_KEY_F5, W_KEY_F6, W_KEY_F7,
	W_KEY_F8, W_KEY_F9, W_KEY_F10, W_KEY_F11, W_KEY_F12, RING, '1', '2', '3', '4', '5',
	'6', '7', '8', '9', '0', '%', CARON, '`', W_KEY_BACKSPACE, W_KEY_TAB, 'Q', 'W',
	'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '/', '(', W_KEY_ENTER,
	W_KEY_CAPSLOCK, 'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', '"', '!',
	W_KEY_LSHIFT, 'Z', 'X', 'C', 'V', 'B', 'N', 'M', '?', ':', '_', W_KEY_RSHIFT,
	W_KEY_LCTRL, W_KEY_LWIN, W_KEY_LALT, ' ', W_KEY_RALT, W_KEY_RWIN, W_KEY_RMENU,
   	W_KEY_RCTRL, W_KEY_PRTSCR, W_KEY_SCROLLOCK, W_KEY_PAUSE, W_KEY_INS, W_KEY_HOME,
	W_KEY_PGUP, W_KEY_DEL, W_KEY_END, W_KEY_PGDN, W_KEY_UP, W_KEY_LEFT, W_KEY_DOWN,
	W_KEY_RIGHT, W_KEY_NUMLOCK, '/', '*', '-', '7', '8', '9', '+', '4', '5', '6',
	'1', '2', '3', W_KEY_ENTER, '0', '.',
};

static t_key_table_elem kam_meta[KEY_TABLE_ELEMS] = {
	0, 0, W_KEY_ESC, W_KEY_F1, W_KEY_F2, W_KEY_F3, W_KEY_F4, W_KEY_F5, W_KEY_F6, W_KEY_F7,
	W_KEY_F8, W_KEY_F9, W_KEY_F10, W_KEY_F11, W_KEY_F12, '`', '1', '2', '3', '4', '5',
	'6', '7', '8', '9', '0', '-', '=', '\\', W_KEY_BACKSPACE, W_KEY_TAB, 'q', 'w',
	'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '[', ']', W_KEY_ENTER, W_KEY_CAPSLOCK,
	'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', '\'', 0, 'z', 'x', 'c',
	'v', 'b', 'n', 'm', ',', '.', '/', W_KEY_RSHIFT, W_KEY_LCTRL, W_KEY_LWIN,
	W_KEY_LALT, ' ', W_KEY_RALT, W_KEY_RWIN, W_KEY_RMENU, W_KEY_RCTRL, W_KEY_PRTSCR,
	W_KEY_SCROLLOCK, W_KEY_PAUSE, W_KEY_INS, W_KEY_HOME, W_KEY_PGUP, W_KEY_DEL, W_KEY_END,
	W_KEY_PGDN, W_KEY_UP, W_KEY_LEFT, W_KEY_DOWN, W_KEY_RIGHT, W_KEY_NUMLOCK,
	'/', '*', '-', '7', '8', '9', '+', '4', '5', '6', '1', '2', '3',
	W_KEY_ENTER, '0', '.',
};

t_composition kam_comp_acute[] = {
	{0, MYSCAN_A, TYPE ''},
	{0, MYSCAN_E, TYPE ''},
	{0, MYSCAN_I, TYPE ''},
	{0, MYSCAN_L, TYPE ''},
	{0, MYSCAN_O, TYPE ''},
	{0, MYSCAN_U, TYPE ''},
	{0, MYSCAN_Y, TYPE ''},
	{1, MYSCAN_A, TYPE ''},
	{1, MYSCAN_E, TYPE ''},
	{1, MYSCAN_I, TYPE ''},
	{1, MYSCAN_L, TYPE ''},
	{1, MYSCAN_O, TYPE ''},
	{1, MYSCAN_U, TYPE ''},
	{1, MYSCAN_Y, TYPE ''},
	{0, MYSCAN_NONE, 0},
};

t_composition kam_comp_caron[] = {
	{0, MYSCAN_C, TYPE ''},
	{0, MYSCAN_D, TYPE ''},
	{0, MYSCAN_E, TYPE ''},
	{0, MYSCAN_L, TYPE ''},
	{0, MYSCAN_N, TYPE ''},
	{0, MYSCAN_R, TYPE ''},
	{0, MYSCAN_S, TYPE ''},
	{0, MYSCAN_T, TYPE ''},
	{0, MYSCAN_Z, TYPE ''},
	{1, MYSCAN_C, TYPE ''},
	{1, MYSCAN_D, TYPE ''},
	{1, MYSCAN_E, TYPE ''},
	{1, MYSCAN_L, TYPE ''},
	{1, MYSCAN_N, TYPE ''},
	{1, MYSCAN_R, TYPE ''},
	{1, MYSCAN_S, TYPE ''},
	{1, MYSCAN_T, TYPE ''},
	{1, MYSCAN_Z, TYPE ''},
	{0, MYSCAN_NONE, 0},
};

t_composition kam_comp_ring[] = {
	{0, MYSCAN_U, TYPE ''},
	{1, MYSCAN_U, TYPE ''},
	{0, MYSCAN_NONE, 0},
};

t_composition kam_comp_dblacute[] = {
	{0, MYSCAN_A, TYPE ''},
	{0, MYSCAN_O, TYPE ''},
	{0, MYSCAN_U, TYPE ''},
	{1, MYSCAN_A, TYPE ''},
	{1, MYSCAN_O, TYPE ''},
	{1, MYSCAN_U, TYPE ''},
	{0, MYSCAN_NONE, 0},
};

t_compose_table kam_compose[] = {
	{ACUTE, kam_comp_acute},
	{CARON, kam_comp_caron},
	{RING, kam_comp_ring},
	{DBLACUTE, kam_comp_dblacute},
	{0, NULL},
};

t_key_layout kam_layout = {
	kam_plain_deadkey,
	kam_shift_deadkey,
	kam_plain,
	kam_shift,
	kam_meta,
	kam_meta,
	kam_meta,
	kam_compose
};

#undef TYPE
#undef RING
#undef DBLACUTE
#undef ACUTE
#undef CARON

#endif

/* vim: set ts=4 cindent shiftwidth=4 tw=0 : */
