#ifndef __MYSCAN_H__
#define __MYSCAN_H__
/*
* These are mine scan codes for the keyboard.
* Why new scancodes? Because real scancodes depends on shift-state of the
* keyboard ... which makes kbd maps implementation too difficult (if not
* impossible). If you have other solution, don't be shy, show me! :)
*/

#define MYSCAN_NONE			0	/* NONE ... no scan */
#define MYSCAN_PLAIN		1	/* Plain ascii entered by Alt + nums */

#define MYSCAN_ESC			2	/* ESC */
#define MYSCAN_F1			3	/* F1 */
#define MYSCAN_F2			4	/* F2 */
#define MYSCAN_F3			5	/* F3 */
#define MYSCAN_F4			6	/* F4 */
#define MYSCAN_F5			7	/* F5 */
#define MYSCAN_F6			8	/* F6 */
#define MYSCAN_F7			9	/* F7 */
#define MYSCAN_F8			10	/* F8 */
#define MYSCAN_F9			11	/* F9 */
#define MYSCAN_F10			12	/* F10 */
#define MYSCAN_F11			13	/* F11 */
#define MYSCAN_F12			14	/* F12 */

#define MYSCAN_BACKQUOTE	15	/* BACKQUOTE */
#define MYSCAN_1			16	/* 1 */
#define MYSCAN_2			17	/* 2 */
#define MYSCAN_3			18	/* 3 */
#define MYSCAN_4			19	/* 4 */
#define MYSCAN_5			20	/* 5 */
#define MYSCAN_6			21	/* 6 */
#define MYSCAN_7			22	/* 7 */
#define MYSCAN_8			23	/* 8 */
#define MYSCAN_9			24	/* 9 */
#define MYSCAN_0			25	/* 0 */
#define MYSCAN_MINUS		26	/* MINUS */
#define MYSCAN_EQUAL		27	/* EQUAL */
#define MYSCAN_BACKSLASH	28	/* BACKSLASH */
#define MYSCAN_BACKSPACE	29	/* BACKSPACE */

#define MYSCAN_TAB			30	/* TAB */
#define MYSCAN_Q			31	/* Q */
#define MYSCAN_W			32	/* W */
#define MYSCAN_E			33	/* E */
#define MYSCAN_R			34	/* R */
#define MYSCAN_T			35	/* T */
#define MYSCAN_Y			36	/* Y */
#define MYSCAN_U			37	/* U */
#define MYSCAN_I			38	/* I */
#define MYSCAN_O			39	/* O */
#define MYSCAN_P			40	/* P */
#define MYSCAN_LBRACKET		41	/* LBRACKET */
#define MYSCAN_RBRACKET		42	/* RBRACKET */
#define MYSCAN_ENTER		43	/* ENTER */

#define MYSCAN_CAPSLOCK		44	/* CAPSLOCK */
#define MYSCAN_A			45	/* A */
#define MYSCAN_S			46	/* S */
#define MYSCAN_D			47	/* D */
#define MYSCAN_F			48	/* F */
#define MYSCAN_G			49	/* G */
#define MYSCAN_H			50	/* H */
#define MYSCAN_J			51	/* J */
#define MYSCAN_K			52	/* K */
#define MYSCAN_L			53	/* L */
#define MYSCAN_SEMICOLON	54	/* SEMICOLON */
#define MYSCAN_QUOTE		55	/* QUOTE */

#define MYSCAN_LSHIFT		56	/* LSHIFT */
#define MYSCAN_Z			57	/* Z */
#define MYSCAN_X			58	/* X */
#define MYSCAN_C			59	/* C */
#define MYSCAN_V			60	/* V */
#define MYSCAN_B			61	/* B */
#define MYSCAN_N			62	/* N */
#define MYSCAN_M			63	/* M */
#define MYSCAN_COMMA		64	/* COMMA */
#define MYSCAN_DOT			65	/* DOT */
#define MYSCAN_SLASH		66	/* SLASH */
#define MYSCAN_RSHIFT		67	/* RSHIFT */

#define MYSCAN_LCTRL		68	/* LCTRL */
#define MYSCAN_LWIN			69	/* LWIN */
#define MYSCAN_LALT			70	/* LALT */
#define MYSCAN_SPACE		71	/* SPACE */
#define MYSCAN_RALT			72	/* RALT */
#define MYSCAN_RWIN			73	/* RWIN */
#define MYSCAN_RMENU		74	/* RMENU */
#define MYSCAN_RCTRL		75	/* RCTRL */

#define MYSCAN_PRTSCR		76	/* PRTSCR */
#define MYSCAN_SCROLLOCK	77	/* SCROLLOCK */
#define MYSCAN_PAUSE		78	/* PAUSE */

#define MYSCAN_INS			79	/* INS */
#define MYSCAN_HOME			80	/* HOME */
#define MYSCAN_PGUP			81	/* PGUP */
#define MYSCAN_DEL			82	/* DEL */
#define MYSCAN_END			83	/* END */
#define MYSCAN_PGDN			84	/* PGDN */

#define MYSCAN_UP			85	/* UP */

#define MYSCAN_LEFT			86	/* LEFT */
#define MYSCAN_DOWN			87	/* DOWN */
#define MYSCAN_RIGHT		88	/* RIGHT */

#define MYSCAN_NUMLOCK		89	/* NUMLOCK */
#define MYSCAN_PAD_SLASH	90	/* PAD_SLASH */
#define MYSCAN_PAD_STAR		91	/* PAD_STAR */
#define MYSCAN_PAD_MINUS	92	/* PAD_MINUS */

#define MYSCAN_PAD_7		93	/* PAD_7 */
#define MYSCAN_PAD_8		94	/* PAD_8 */
#define MYSCAN_PAD_9		95	/* PAD_9 */
#define MYSCAN_PAD_PLUS		96	/* PAD_PLUS */

#define MYSCAN_PAD_4		97	/* PAD_4 */
#define MYSCAN_PAD_5		98	/* PAD_5 */
#define MYSCAN_PAD_6		99	/* PAD_6 */

#define MYSCAN_PAD_1		100	/* PAD_1 */
#define MYSCAN_PAD_2		101	/* PAD_2 */
#define MYSCAN_PAD_3		102	/* PAD_3 */
#define MYSCAN_PAD_ENTER	103	/* PAD_ENTER */

#define MYSCAN_PAD_0		104	/* PAD_0 */
#define MYSCAN_PAD_DOT		105	/* PAD_DOT */

#endif

/* vim: set ts=4 cindent shiftwidth=4 tw=0 : */
