
/* Terminality - a portable terminal handling library
 * Copyright (C) 1998-2002, Emil Mikulic.
 * This is LGPL - look at COPYING.LIB
 */

/* $Id: myscheme.h,v 1.5 2002/07/26 01:39:43 darkmoon Exp $ */

/* Project:     Terminality
 * File:	myscheme.h
 * Author:      Michal Safranek
 * Description: Color themes
 */

#ifndef __MYSCHEME_H__
#define __MYSCHEME_H__

#include "tn.h"

color my_color_scheme[] = {
	/* checkbox: */
	Blue,		/* COLOR_CHECKBOX_BG */
	Blue,		/* COLOR_CHECKBOX_LABELBG */
	Blue,		/* COLOR_CHECKBOX_CHECKBG */
	Blue,		/* COLOR_CHECKBOX_BOXBG */
	Blue,		/* COLOR_CHECKBOX_SLABELBG */
	Blue,		/* COLOR_CHECKBOX_SCHECKBG */
	Blue,		/* COLOR_CHECKBOX_SBOXBG */
	Cyan,		/* COLOR_CHECKBOX_LABEL */
	LightCyan,	/* COLOR_CHECKBOX_SLABEL */
	Cyan,		/* COLOR_CHECKBOX_BOX */
	Cyan,		/* COLOR_CHECKBOX_SCHECK */
	LightCyan,	/* COLOR_CHECKBOX_SBOX */
	LightCyan,	/* COLOR_CHECKBOX_CHECK */
	/* Button: */
	Blue,		/* COLOR_BUTTON_BG */
	Cyan,		/* COLOR_BUTTON_TEXT */
	Cyan,		/* COLOR_BUTTON_BR */
	Cyan,		/* COLOR_BUTTON_STL */
	LightCyan,	/* COLOR_BUTTON_SBR */
	LightCyan,	/* COLOR_BUTTON_TL */
	LightCyan,	/* COLOR_BUTTON_STEXT */
	LightGray,	/* COLOR_BUTTON_DTEXT */
	White,		/* COLOR_BUTTON_SDTEXT */
	/* Form: */
	Blue,		/* COLOR_FORM_BG */
	LightCyan,	/* COLOR_FORM_TL */
	Cyan,		/* COLOR_FORM_BR */
	/* hMenu: */
	Blue,		/* COLOR_HMENU_BG */
	Blue,		/* COLOR_HMENU_SITEMBG */
	Blue,		/* COLOR_HMENU_ITEMBG */
	Cyan,		/* COLOR_HMENU_ITEM */
	LightCyan,	/* COLOR_HMENU_SITEM */
	/* listingItem: */
	Blue,		/* COLOR_LITEM_ITEMBG */
	Blue,		/* COLOR_LITEM_EMPTYBG */
	Blue,		/* COLOR_LITEM_HEADINGBG */
	Blue,		/* COLOR_LITEM_MOREBG */
	LightCyan,	/* COLOR_LITEM_MORE */
	LightCyan,	/* COLOR_LITEM_HEADING */
	Cyan,		/* COLOR_LITEM_ITEM */
	Cyan,		/* COLOR_LITEM_SITEMBG */
	Cyan,		/* COLOR_LITEM_SMOREBG */
	Red,		/* COLOR_LITEM_EMPTY */
	Red,		/* COLOR_LITEM_SEMPTYBG */
	Blue,		/* COLOR_LITEM_SITEM */
	Blue,		/* COLOR_LITEM_SEMPTY */
	Blue,		/* COLOR_LITEM_SMORE */
	/* listing: */
	Blue,		/* COLOR_LISTING_BG */
	/* menu: */
	Blue,		/* COLOR_MENU_FRAMEBG */
	Blue,		/* COLOR_MENU_ITEMBG */
	LightCyan,	/* COLOR_MENU_SCROLL */
	LightCyan,	/* COLOR_MENU_FRAME */
	LightCyan,	/* COLOR_MENU_CORNER */
	Cyan,		/* COLOR_MENU_ITEM */
	LightCyan,	/* COLOR_MENU_SITEM */
	Cyan,		/* COLOR_MENU_SITEMBG */
	/* textbox: */
	Cyan,		/* COLOR_TEXTBOX_FRAME */
	Cyan,		/* COLOR_TEXTBOX_SPACE */
	Cyan,		/* COLOR_TEXTBOX_SSPACE */
	Blue,		/* COLOR_TEXTBOX_TEXTBG */
	Blue,		/* COLOR_TEXTBOX_SPACEBG */
	Blue,		/* COLOR_TEXTBOX_FRAMEBG */
	Blue,		/* COLOR_TEXTBOX_STEXTBG */
	Blue,		/* COLOR_TEXTBOX_SSPACEBG */
	Blue,		/* COLOR_TEXTBOX_SFRAMEBG */
	Cyan,		/* COLOR_TEXTBOX_TEXT */
	LightCyan,	/* COLOR_TEXTBOX_STEXT */
	LightCyan,	/* COLOR_TEXTBOX_SFRAME */
	/* staticLabel: */
	Blue,		/* COLOR_SLABEL_BG */
	LightGray,	/* COLOR_SLABEL_FG */
	/* textarea: */
	Cyan,		/* COLOR_TEXTAREA_FRAME */
	Cyan,		/* COLOR_TEXTAREA_SPACE */
	Cyan,		/* COLOR_TEXTAREA_SSPACE */
	Blue,		/* COLOR_TEXTAREA_TEXTBG */
	Blue,		/* COLOR_TEXTAREA_SPACEBG */
	Blue,		/* COLOR_TEXTAREA_FRAMEBG */
	Blue,		/* COLOR_TEXTAREA_STEXTBG */
	Blue,		/* COLOR_TEXTAREA_SSPACEBG */
	Blue,		/* COLOR_TEXTAREA_SFRAMEBG */
	Cyan,		/* COLOR_TEXTAREA_TEXT */
	LightCyan,	/* COLOR_TEXTAREA_STEXT */
	LightCyan,	/* COLOR_TEXTAREA_SFRAME */
	Blue,		/* COLOR_PBAR_BG */
	LightGray,	/* COLOR_PBAR_NONE */
	LightRed,	/* COLOR_PBAR_LOW */
	Yellow,		/* COLOR_PBAR_MID */
	Green,		/* COLOR_PBAR_HI */
	White,		/* COLOR_PBAR_PERC */
};

#endif

