
/* Terminality - a portable terminal handling library
 * Copyright (C) 1998-2002, Emil Mikulic.
 * This is LGPL - look at COPYING.LIB
 */

/* $Id: precalc.h,v 1.7 2002/07/26 01:39:43 darkmoon Exp $ */

/* Project:     Terminality
 * File:	precalc.h
 * Author:      Emil Mikulic
 * Description: ANSI-artifier precalc generator (header file)
 */

#ifndef _precalc_h
#define _precalc_h

#include <math.h>
#include <signal.h>
#include "tn.h"



#ifdef __cplusplus
extern "C" {
#endif

/* Definition of superchar structure */
typedef struct superchar {
	unsigned char attr;	/* attribute */
	unsigned char chr;	/* character */
} superchar;



void precalc(void);
void putsc(superchar sc);
superchar get_monochrome(unsigned char c);
superchar get_monochrome_shape(unsigned char p1, unsigned char p2,
	unsigned char p3, unsigned char p4);
superchar get_rgb_block(unsigned char r, unsigned char g, unsigned char b);



#ifdef __cplusplus
}
#endif

#endif

