
/* Terminality - a portable terminal handling library
 * Copyright (C) 1998-2002, Emil Mikulic.
 * This is LGPL - look at COPYING.LIB
 */

/* Project:     Terminality/GUI
 * File:	lclhndl.cpp
 * Author:      Michal Safranek
 * Description: Local handle implementation
 */

#include <gui.h>

const char lclhandl_rcsid[] =
"$Id: lclhndl.cpp,v 1.2 2002/07/26 01:39:40 darkmoon Exp $";



localHandle::localHandle()
{
	local_keys = NULL;
}



localHandle::~localHandle()
{
	if(local_keys){
		real_delete_keys(&local_keys);
	}
}



int localHandle::bind(key k, key (*fce)(int, element_type, void *),
		int overwrite)
{
	return real_register_key(&local_keys, k, fce, overwrite);
}



int localHandle::unbind(key k)
{
	return real_unregister_key(&local_keys, k);
}



void localHandle::removeall(void)
{
	real_delete_keys(&local_keys);
}



key localHandle::keyhandler(key k, element_type type)
{
	return real_handle_key(&local_keys, k, type, this);
}

